{{! template-lint-disable no-action }}
<div class="certification-informations">
  <div class="certification-informations__row">
    <PixButton @route="authenticated.users.get" @size="small" @model={{this.certification.userId}}>
      Voir les détails de l'utilisateur
    </PixButton>
    {{#if this.certification.isCancelled}}
      <PixButton @backgroundColor="red" @size="small" @triggerAction={{this.onUncancelCertificationButtonClick}}>
        Désannuler la certification
      </PixButton>
    {{else}}
      <PixButton @backgroundColor="red" @size="small" @triggerAction={{this.onCancelCertificationButtonClick}}>
        Annuler la certification
      </PixButton>
    {{/if}}
  </div>

  <div class="certification-informations__row">
    <div class="certification-informations__card {{if this.editingCandidateResults 'border-primary'}}">
      <h2 class="certification-informations__card__title">
        <Certifications::InfoTag @record={{this.certification}} @float={{true}} />État
      </h2>
      <Certifications::InfoField
        @value={{this.certification.sessionId}}
        @edition={{false}}
        @label="Session :"
        @linkRoute="authenticated.sessions.session"
      />
      <Certifications::StatusSelect @certification={{this.certification}} @edition={{this.editingCandidateResults}} />
      <Certifications::InfoField @value={{this.certification.creationDate}} @edition={{false}} @label="Créée le :" />
      <Certifications::InfoField
        @value={{this.certification.completionDate}}
        @edition={{false}}
        @label="Terminée le :"
      />
      <Certifications::InfoField @value={{this.certification.publishedText}} @edition={{false}} @label="Publiée :" />
    </div>

    <div class="certification-informations__card {{if this.editingCandidateInformations 'border-primary'}}">
      <h2 class="certification-informations__card__title">Candidat</h2>
      <div class="certification-info-field">
        <span>Prénom :</span>
        <span>{{this.certification.firstName}}</span>
      </div>
      <div class="certification-info-field">
        <span>Nom de famille :</span>
        <span>{{this.certification.lastName}}</span>
      </div>
      <div class="certification-info-field">
        <span>Date de naissance :</span>
        <span>{{dayjs-format this.certification.birthdate "DD/MM/YYYY" allow-empty=true}}</span>
      </div>
      <div class="certification-info-field">
        <span>Sexe :</span>
        <span>{{this.certification.sex}}</span>
      </div>
      <div class="certification-info-field">
        <span>Commune de naissance :</span>
        <span>{{this.certification.birthplace}}</span>
      </div>
      <div class="certification-info-field">
        <span>Code postal de naissance :</span>
        <span>{{this.certification.birthPostalCode}}</span>
      </div>
      <div class="certification-info-field">
        <span>Code INSEE de naissance :</span>
        <span>{{this.certification.birthInseeCode}}</span>
      </div>
      <div class="certification-info-field">
        <span>Pays de naissance :</span>
        <span>{{this.certification.birthCountry}}</span>
      </div>

      <div class="candidate-informations__actions">
        <PixButton
          @size="small"
          @triggerAction={{this.openCandidateEditModal}}
          aria-label="Modifier les informations du candidat"
          @isDisabled={{this.isModifyButtonDisabled}}
        >
          Modifier
        </PixButton>
        {{#if this.certification.wasRegisteredBeforeCPF}}
          <span class="candidate-informations__warning-cpf-message">Voir avec PO/Dev pour modifier les infos candidat.</span>
        {{/if}}
      </div>
    </div>
  </div>

  {{#if this.certification.hasComplementaryCertifications}}
    <div class="certification-informations__row">
      <div class="certification-informations__card">
        <h2 class="certification-informations__card__title">Certifications complémentaires</h2>

        {{#if this.certification.commonComplementaryCertificationCourseResults}}
          <ul class="certification-informations__card__list">
            {{#each
              this.certification.commonComplementaryCertificationCourseResults
              as |commonComplementaryCertificationCourseResult|
            }}
              <li class="certification-informations__card__list-item">
                <span class="certification-informations__card__list-label">
                  {{commonComplementaryCertificationCourseResult.label}}
                  :
                </span>
                {{commonComplementaryCertificationCourseResult.status}}
              </li>
            {{/each}}
          </ul>
        {{/if}}

        {{#if this.certification.complementaryCertificationCourseResultsWithExternal}}
          <section class="certification-informations__pix-edu">
            <h2 class="certification-informations__pix-edu__title">Résultats de la certification complémentaire Pix+ Edu
              :</h2>
            <div class="certification-informations__row">
              <div class="certification-informations__card certification-informations__card--pix-edu">
                <p>VOLET PIX</p>
                <p class="certification-informations__card__score">
                  {{this.certification.complementaryCertificationCourseResultsWithExternal.pixResult}}
                </p>
              </div>
              <div class="certification-informations__card certification-informations__card--pix-edu">
                <p>VOLET JURY</p>
                {{#if this.displayJuryLevelSelect}}
                  <div class="certification-informations__pix-edu__row__jury-level-editor">
                    <section>
                      <PixSelect
                        @label="Sélectionner un niveau"
                        @screenReaderOnly={{true}}
                        @options={{this.juryLevelOptions}}
                        @value={{this.selectedJuryLevel}}
                        @hideDefaultOption={{true}}
                        @onChange={{this.selectJuryLevel}}
                        @placeholder="Choisir un niveau"
                      />
                    </section>
                    <section>
                      <PixButton
                        @backgroundColor="transparent-light"
                        @isBorderVisible="true"
                        @size="small"
                        @triggerAction={{this.onCancelJuryLevelEditButtonClick}}
                      >
                        Annuler
                      </PixButton>
                      <PixButton
                        @size="small"
                        @triggerAction={{this.onEditJuryLevelSave}}
                        aria-label="Modifier le niveau du jury"
                        @isDisabled={{this.isModifyButtonDisabled}}
                      >
                        Enregistrer
                      </PixButton>
                    </section>
                  </div>
                {{else}}
                  <div class="certification-informations__pix-edu__row__jury-level">
                    <p class="certification-informations__card__score">
                      {{this.certification.complementaryCertificationCourseResultsWithExternal.externalResult}}
                    </p>
                    {{#if this.shouldDisplayJuryLevelEditButton}}
                      <button
                        type="button"
                        class="jury-level-edit-icon-button"
                        aria-label="Modifier le volet jury"
                        {{on "click" this.editJury}}
                      >
                        <FaIcon @icon="pen-to-square" />
                      </button>
                    {{/if}}
                  </div>
                {{/if}}
              </div>
              <div class="certification-informations__card certification-informations__card--pix-edu">
                <p>NIVEAU FINAL</p>
                <p
                  class="certification-informations__card__score"
                >{{this.certification.complementaryCertificationCourseResultsWithExternal.finalResult}}</p>
              </div>
            </div>
          </section>
        {{/if}}
      </div>
    </div>
  {{/if}}

  {{#if this.hasIssueReports}}
    <section
      class="certification-informations__row certification-informations__card certification-informations__certification-issue-reports"
    >
      <h2 class="card-title certification-informations__card__title">Signalements</h2>
      <Certifications::IssueReports
        @hasImpactfulIssueReports={{this.hasImpactfulIssueReports}}
        @hasUnimpactfulIssueReports={{this.hasUnimpactfulIssueReports}}
        @impactfulCertificationIssueReports={{this.impactfulCertificationIssueReports}}
        @unimpactfulCertificationIssueReports={{this.unimpactfulCertificationIssueReports}}
        @resolveIssueReport={{this.resolveIssueReport}}
      />
    </section>
  {{/if}}

  <div class="certification-informations__row">
    <div class="certification-informations__card {{if this.editingCandidateResults 'border-primary'}}">
      <h2 class="certification-informations__card__title">Commentaires jury</h2>
      <Certifications::InfoField
        @value={{this.certification.commentForCandidate}}
        @edition={{this.editingCandidateResults}}
        @label="Pour le candidat :"
        @fieldId="certification-commentForCandidate"
        @isTextarea={{true}}
      />
      <Certifications::InfoField
        @value={{this.certification.commentForOrganization}}
        @edition={{this.editingCandidateResults}}
        @label="Pour l'organisation :"
        @fieldId="certification-commentForOrganization"
        @isTextarea={{true}}
      />
      <Certifications::InfoField
        @value={{this.certification.commentForJury}}
        @edition={{this.editingCandidateResults}}
        @label="Pour le jury :"
        @fieldId="certification-commentForJury"
        @isTextarea={{true}}
      />
      <Certifications::InfoField
        @value={{this.certification.juryId}}
        @edition={{false}}
        @label="Identifiant jury :"
        @isTextarea={{true}}
      />
    </div>

  </div>
  <div class="certification-informations__row">
    <div class="certification-informations__card {{if this.editingCandidateResults 'border-primary'}}">
      <h2 class="certification-informations__card__title">Résultats</h2>
      <Certifications::InfoField
        @value={{this.certification.pixScore}}
        @edition={{this.editingCandidateResults}}
        @label="Score :"
        @fieldId="certification-pixScore"
        @suffix=" points"
      />

      <Certifications::CompetenceList
        @competences={{this.certification.competences}}
        @edition={{this.editingCandidateResults}}
        @onUpdateScore={{this.onUpdateScore}}
        @onUpdateLevel={{this.onUpdateLevel}}
      />
    </div>
  </div>
  {{#if this.isValid}}
    <div class="certification-informations__row certification-informations__row--center">
      {{#if this.editingCandidateResults}}
        <PixButton
          @size="small"
          @backgroundColor="transparent-light"
          @isBorderVisible={{true}}
          @triggerAction={{this.onCandidateResultsCancel}}
          aria-label="Annuler la modification des résultats du candidat"
        >
          Annuler
        </PixButton>
        <PixButton
          @size="small"
          @triggerAction={{this.onCandidateResultsSaveConfirm}}
          @backgroundColor="green"
          aria-label="Enregistrer les résultats du candidat"
        >
          Enregistrer
        </PixButton>
      {{else}}
        <PixButton
          @size="small"
          @triggerAction={{this.onCandidateResultsEdit}}
          aria-label="Modifier les résultats du candidat"
          @isDisabled={{this.editingCandidateInformations}}
        >
          Modifier
        </PixButton>
      {{/if}}
    </div>
  {{/if}}
</div>

<ConfirmPopup
  @message={{this.confirmMessage}}
  @error={{this.confirmErrorMessage}}
  @confirm={{action this.confirmAction}}
  @cancel={{action this.onCandidateResultsCancelConfirm}}
  @show={{this.displayConfirm}}
/>

{{#if this.isCandidateEditModalOpen}}
  <Certifications::CandidateEditModal
    @onCancelButtonsClicked={{this.closeCandidateEditModal}}
    @onFormSubmit={{this.onCandidateInformationSave}}
    @candidate={{this.certification}}
    @countries={{this.countries}}
    @isDisplayed={{this.isCandidateEditModalOpen}}
  />
{{/if}}